import java.util.*;

public class PhoneType {
    public static final PhoneType WORK   = new PhoneType(0, "Work", "Office");
    public static final PhoneType HOME   = new PhoneType(1, "Home");
    public static final PhoneType MAIN   = new PhoneType(2, "Main");
    public static final PhoneType MOBILE = new PhoneType(3, "Mobile", "Cell");
    public static final PhoneType FAX    = new PhoneType(4, "Fax");
    public static final PhoneType PAGER  = new PhoneType(5, "Pager", "Beeper");
    public static final PhoneType EMAIL  = new PhoneType(6, "Email");

    private int _idx;
    private List<String> _names;
    private static Collection<PhoneType> _types;

    private PhoneType(int idx, String... names) {
	if (_types == null)
	    _types = new HashSet<PhoneType>();

	_idx = idx;
	_names = new ArrayList<String>();
	for (String name : names)
	    _names.add(name);
	_types.add(this);
    }

    public int index() {
	return _idx;
    }

    public String name() {
	return _names.get(0);
    }

    public static PhoneType findByName(String name) {
	for (PhoneType t: _types)
	    for (String tName: t._names)
		if (tName.equalsIgnoreCase(name))
		    return t;
	return null;
    }

    public static PhoneType findByIndex(int idx) {
	for (PhoneType t: _types)
	    if (t.index() == idx)
		return t;
	return null;
    }
}
